/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 *
 * @author omozegieaziegbe
 */
public class JdbcToCsvExporter {

    public static void main(String[] args) {
        String url = "jdbc:mysql://localhost:3306/customer";
        String username = "root";
        String password = "omozegie";
        String query = "SELECT * FROM customers";  // Replace with your SQL query

        try (Connection connection = DriverManager.getConnection(url, username, password); PreparedStatement statement = connection.prepareStatement(query); ResultSet resultSet = statement.executeQuery()) {

            // Define the CSV file path
            String csvFile = "customers.csv";

            // Create a BufferedWriter to write to the CSV file
            try (BufferedWriter writer = new BufferedWriter(new FileWriter(csvFile))) {
                // Write the header (column names)
                int columnCount = resultSet.getMetaData().getColumnCount();
                for (int i = 1; i <= columnCount; i++) {
                    writer.write(resultSet.getMetaData().getColumnName(i));
                    if (i < columnCount) {
                        writer.write(",");
                    }
                }
                writer.newLine();

                // Write the data rows
                while (resultSet.next()) {
                    for (int i = 1; i <= columnCount; i++) {
                        writer.write(resultSet.getString(i));
                        if (i < columnCount) {
                            writer.write(",");
                        }
                    }
                    writer.newLine();
                }

                System.out.println("CSV file created successfully at: " + csvFile);
            } catch (IOException e) {
                System.err.println("Error writing to CSV file: " + e.getMessage());
            }

        } catch (SQLException e) {
            System.err.println("SQL error: " + e.getMessage());
        }
    }
}
