/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

/**
 *
 * @author omozegieaziegbe
 */
import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVPrinter;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class JdbcToCsvWithApacheCommons {

    public static void main(String[] args) {
        String url = "jdbc:mysql://localhost:3306/customer";
        String username = "root";
        String password = "omozegie";
        String query = "SELECT * FROM customers";  

        try (Connection connection = DriverManager.getConnection(url, username, password);
             PreparedStatement statement = connection.prepareStatement(query);
             ResultSet resultSet = statement.executeQuery()) {

            // Define the CSV file path
            String csvFile = "customers_commons.csv";

            // Create a BufferedWriter to write to the CSV file
            try (BufferedWriter writer = new BufferedWriter(new FileWriter(csvFile));
                 CSVPrinter csvPrinter = new CSVPrinter(writer, CSVFormat.DEFAULT.withHeader(getColumnNames(resultSet)))) {

                // Write the rows
                while (resultSet.next()) {
                    for (int i = 1; i <= resultSet.getMetaData().getColumnCount(); i++) {
                        csvPrinter.print(resultSet.getString(i));
                    }
                    csvPrinter.println();
                }

                csvPrinter.flush();  // Ensure data is written to the file
                System.out.println("CSV file created successfully at: " + csvFile);
            } catch (IOException e) {
                System.err.println("Error writing to CSV file: " + e.getMessage());
            }

        } catch (SQLException e) {
            System.err.println("SQL error: " + e.getMessage());
        }
    }

    // Helper method to get the column names from the ResultSet
    private static String[] getColumnNames(ResultSet resultSet) throws SQLException {
        int columnCount = resultSet.getMetaData().getColumnCount();
        String[] columnNames = new String[columnCount];
        for (int i = 0; i < columnCount; i++) {
            columnNames[i] = resultSet.getMetaData().getColumnName(i + 1);
        }
        return columnNames;
    }
}
